Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# IdePortal Class Reference

`#include <dePortal.hpp>`

Inheritance diagram for IdePortal:

[legend]
List of all members.

## Public Member Functions
virtual int | Release ()=0
| deletes the object
virtual IdeVertexBuffer * | GetVBuffer ()=0
| Retrieve a pointer to the portal's vertex buffer.
virtual deBoolean | IsTPortal () const=0
| Tell whether or not the portal is a T-portal (has normal and transformation).
virtual void | SetTPortal (deBoolean TPortal)=0
| Disable any T-portal behavior this portal might have.
virtual deBoolean | ClipFrustum (const deTransformInfo &CamPos, const IdePlaneFrustum *in, IdePlaneFrustum *out)=0
| Clip the view frustum of a camera to the screen projection of the portal.
virtual deBoolean | IntersectsFrustum (const deTransformInfo &CamPos, const IdePlaneFrustum *f) const=0
| Test whether the input view frustum potentially contains any part of the portal.
virtual void | SetVertices (deVec3d Vertices[], long Num)=0
virtual deVec3d * | GetVertices (long &Num) const=0
virtual deWorldID | GetLinkWorldID () const=0
| Retrieve the world ID of the Scene Room on the "other side" of the portal.
virtual deObjectID | GetLinkObjectID () const=0
| Retrieve the object ID of the Scene Room on the "other side" of the portal.
virtual void | SetLinkWorldID (deWorldID WorldID)=0
| Set the world ID of the Scene Room on the "other side" of the portal.
virtual void | SetLinkObjectID (deObjectID ObjectID)=0
| Set the object ID of the Scene Room on the "other side" of the portal.
virtual deBoolean | LinkTo (IdeSceneRoom *SceneRoom)=0
| Feed in a Scene Room to have the world and object ID's matched up for you.
virtual void | SetNormal (const deVec3d &v)=0
| Set the "face" normal of the portal.
virtual void | GetNormal (deVec3d &v) const=0
| Retrieve the "face" normal of the portal.
virtual deBoolean | IsPlanar ()=0
virtual void | SetPosition (const deTransformInfo &Matrix)=0
| Set the world transformation of the portal's position.
virtual void | GetPosition (deTransformInfo &Matrix) const=0
| Retrieve the world transformation of the portal's position.
virtual void | SetTransform (const deTransformInfo &Matrix)=0
virtual void | GetTransform (deTransformInfo &Matrix) const=0
| Retrieve the portal's transformation matrix.
virtual void | ConcatTransform (deTransformInfo &Matrix)=0
## Protected Member Functions
| ~IdePortal ()

## Detailed Description

portals are used to connect IdeSceneRoom instances that would otherwise be unconnected. Related functions: IdePortal_CreatePortal, IdePortal_CreatePortalWithVerts.

## Constructor & Destructor Documentation

IdePortal::~IdePortal | ( |  | ) | `[inline, protected]`

## Member Function Documentation

virtual deBoolean IdePortal::ClipFrustum | ( | const deTransformInfo & | CamPos,
|  | const IdePlaneFrustum * | in,
|  | IdePlaneFrustum * | out
| ) | `[pure virtual]`

| Clip the view frustum of a camera to the screen projection of the portal. Implemented in dePortal.

virtual void IdePortal::ConcatTransform | ( | deTransformInfo & | Matrix | ) | `[pure virtual]`

  | Concatenate the portal's world transformation with another transform Parameters:
  Matrix | a matrix containing a current world transform, to be concatenated with the portal's world transformation
Implemented in dePortal.

virtual deObjectID IdePortal::GetLinkObjectID | ( |  | ) | const`[pure virtual]`

| Retrieve the object ID of the Scene Room on the "other side" of the portal. Implemented in dePortal.

virtual deWorldID IdePortal::GetLinkWorldID | ( |  | ) | const`[pure virtual]`

| Retrieve the world ID of the Scene Room on the "other side" of the portal. Implemented in dePortal.

virtual void IdePortal::GetNormal | ( | deVec3d & | v | ) | const`[pure virtual]`

| Retrieve the "face" normal of the portal. Implemented in dePortal.

virtual void IdePortal::GetPosition | ( | deTransformInfo & | Matrix | ) | const`[pure virtual]`

| Retrieve the world transformation of the portal's position. Implemented in dePortal.

virtual void IdePortal::GetTransform | ( | deTransformInfo & | Matrix | ) | const`[pure virtual]`

| Retrieve the portal's transformation matrix. Implemented in dePortal.

virtual IdeVertexBuffer* IdePortal::GetVBuffer | ( |  | ) | `[pure virtual]`

| Retrieve a pointer to the portal's vertex buffer. Implemented in dePortal.

virtual deVec3d* IdePortal::GetVertices | ( | long & | Num | ) | const`[pure virtual]`

  | Retrieve the internally held vertices Returns: pointer to the internal vertex array Parameters:
  Num | a reference to a long int to be filled with the number of vertices
Implemented in dePortal.

virtual deBoolean IdePortal::IntersectsFrustum | ( | const deTransformInfo & | CamPos,
|  | const IdePlaneFrustum * | f
| ) | const`[pure virtual]`

| Test whether the input view frustum potentially contains any part of the portal. Implemented in dePortal.

virtual deBoolean IdePortal::IsPlanar | ( |  | ) | `[pure virtual]`

| Implemented in dePortal.

virtual deBoolean IdePortal::IsTPortal | ( |  | ) | const`[pure virtual]`

| Tell whether or not the portal is a T-portal (has normal and transformation). Implemented in dePortal.

virtual deBoolean IdePortal::LinkTo | ( | IdeSceneRoom * | SceneRoom | ) | `[pure virtual]`

| Feed in a Scene Room to have the world and object ID's matched up for you. Implemented in dePortal.

virtual int IdePortal::Release | ( |  | ) | `[pure virtual]`

| deletes the object Implemented in dePortal.

virtual void IdePortal::SetLinkObjectID | ( | deObjectID | ObjectID | ) | `[pure virtual]`

| Set the object ID of the Scene Room on the "other side" of the portal. Implemented in dePortal.

virtual void IdePortal::SetLinkWorldID | ( | deWorldID | WorldID | ) | `[pure virtual]`

| Set the world ID of the Scene Room on the "other side" of the portal. Implemented in dePortal.

virtual void IdePortal::SetNormal | ( | const deVec3d & | v | ) | `[pure virtual]`

| Set the "face" normal of the portal. Implemented in dePortal.

virtual void IdePortal::SetPosition | ( | const deTransformInfo & | Matrix | ) | `[pure virtual]`

| Set the world transformation of the portal's position. Implemented in dePortal.

virtual void IdePortal::SetTPortal | ( | deBoolean | TPortal | ) | `[pure virtual]`

| Disable any T-portal behavior this portal might have. Implemented in dePortal.

virtual void IdePortal::SetTransform | ( | const deTransformInfo & | Matrix | ) | `[pure virtual]`

| Set the portal's transformation matrix. This matrix is used to get a concatenated world matrix for objects on the "other side" of the portal Implemented in dePortal.

virtual void IdePortal::SetVertices | ( | deVec3d | Vertices[],
|  | long | Num
| ) | `[pure virtual]`

  | Set the vertices of the portal. For a T-portal, these vertices must be planar Parameters:
  Vertices | an array of vertices to set the internal vertices to
  Num | the number of vertices in the array
Implemented in dePortal.

The documentation for this class was generated from the following file:

- dePortal.hpp